﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="msxsl"
                xmlns:msc="http://janglin.com/Sycamores/MobileShare/Client/applicationData"
>
  <xsl:output method="xml" indent="yes"/>

  <xsl:template match="msc:applicationData">
    <html>
      <head>
        <title></title>
        <style type="text/css">
          #Checkbox1
          {
          width: 20px;
          }
        </style>
      </head>
      <body style="font-family: 'Segoe Condensed'">

        <p>
          <div style="font-size: large; font-weight: bold;">
            Mobile Share for Windows
          </div>
          <br/>
          Client Application Data
          (v <xsl:value-of select="@version"/>)
        </p>
        <p>
          <xsl:call-template name="CheckBox">
            <xsl:with-param name="value" select="msc:hideSystemFiles" />
          </xsl:call-template>
          <b>Hide Protected Operating System Files</b>
        </p>
        <p>
          <xsl:call-template name="CheckBox">
            <xsl:with-param name="value" select="msc:hideExtensions" />
          </xsl:call-template>
          <b>Hide Extensions</b>
        </p>
        <p>
          <xsl:call-template name="CheckBox">
            <xsl:with-param name="value" select="msc:showHiddenFiles" />
          </xsl:call-template>
          <b>Show Hidden &amp; System Files</b>
        </p>
        <p>
          <xsl:call-template name="CheckBox">
            <xsl:with-param name="value" select="msc:saveAccount" />
          </xsl:call-template>
          <b>Save user information (using cookies).</b>
        </p>
        <p>
          <b>Target Server:</b> &quot;<xsl:value-of select="msc:targetServer"/>&quot;
        </p>
        <p>
          <div style="font-weight: bold">
            Available Servers:
          </div>
          <br/>
          <xsl:for-each select="msc:server">
            <b>
              <xsl:value-of select="@id"/>:
            </b>&#160;&#160;&#160;<xsl:call-template name="Hlink">
              <xsl:with-param name="server" select="."/>
            </xsl:call-template>
            <br/>
          </xsl:for-each>
        </p>
      </body>
    </html>
  </xsl:template>

  <xsl:template name="CheckBox">
    <xsl:param name="value" />
    <xsl:text disable-output-escaping="yes">&#60;input type="checkbox"</xsl:text>
    <xsl:call-template name="Checked">
      <xsl:with-param name="value" select="$value"/>
    </xsl:call-template>
    <xsl:text disable-output-escaping="yes">/&#62;</xsl:text>
  </xsl:template>

  <xsl:template name="Checked">
    <xsl:param name="value" />
    <xsl:if test="$value='true'">
      <xsl:text> checked="checked"</xsl:text> 
    </xsl:if>
  </xsl:template>

  <xsl:template name="Url">
    <xsl:param name="server"/>
    http://<xsl:value-of select="$server/msc:base"/>:<xsl:value-of select="$server/msc:port"/>/<xsl:value-of select="$server/msc:address"/>
  </xsl:template>

  <xsl:template name="Hlink">
    <xsl:param name="server"/>
    <xsl:text disable-output-escaping="yes">&#60;a href="</xsl:text>
    <xsl:call-template name="Url">
      <xsl:with-param name="server" select="$server"/>
    </xsl:call-template>
    <xsl:text disable-output-escaping="yes">"&#62;</xsl:text>
    <xsl:call-template name="Url">
      <xsl:with-param name="server" select="$server"/>
    </xsl:call-template>
    <xsl:text disable-output-escaping="yes">&#60;/a&#62;</xsl:text>
  </xsl:template>
</xsl:stylesheet>