﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="msxsl"
    xmlns:msc="http://janglin.com/Sycamores/MobileShare/Client/applicationData"
>
  <xsl:output method="xml" indent="yes"/>

  <xsl:template match="msc:applicationData">
    <xsl:text disable-output-escaping="yes">&#60;?xml-stylesheet type="text/xsl" href="./ApplicationData.xslt"?&#62;</xsl:text>
    <applicationData version="1.0.3"
 xmlns="http://janglin.com/Sycamores/MobileShare/Client/applicationData"
 xmlns:msc="http://janglin.com/Sycamores/MobileShare/Client/applicationData" >
      <hideSystemFiles>
        <xsl:value-of select="msc:hideSystemFiles"/>
      </hideSystemFiles>
      <hideExtensions>
        <xsl:value-of select="msc:hideExtensions"/>
      </hideExtensions>
      <showHiddenFiles>
        <xsl:value-of select="msc:showHiddenFiles"/>
      </showHiddenFiles>
      <targetServer>
        <xsl:value-of select="msc:targetServer"/>
      </targetServer>
      <defaultAccount>
        <xsl:value-of select="msc:defaultAccount"/>
      </defaultAccount>
      <xsl:for-each select="msc:account">
        <xsl:call-template name="account">
          <xsl:with-param name="id" select="./@id"/>
          <xsl:with-param name="user" select="./msc:user"/>
          <xsl:with-param name="password" select="./msc:password"/>
          <xsl:with-param name="domain" select="./msc:domain"/>
        </xsl:call-template>
      </xsl:for-each>
      <xsl:for-each select="msc:server">
        <xsl:call-template name="server">
          <xsl:with-param name="this" select="."/>
        </xsl:call-template>
      </xsl:for-each>
    </applicationData>
  </xsl:template>

  <xsl:template name="account">
    <xsl:param name="id"/>
    <xsl:param name="user"/>
    <xsl:param name="password"/>
    <xsl:param name="domain"/>
    <xsl:text disable-output-escaping="yes">&#60;account id="</xsl:text>
    <xsl:value-of select="$id"/>
    <xsl:text disable-output-escaping="yes">"&#62;</xsl:text>
    <user xmlns="http://janglin.com/Sycamores/MobileShare/Client/applicationData">
      <xsl:value-of select="$user"/>
    </user>
    <password xmlns="http://janglin.com/Sycamores/MobileShare/Client/applicationData">
      <xsl:value-of select="$password"/>
    </password>
    <domain xmlns="http://janglin.com/Sycamores/MobileShare/Client/applicationData">
      <xsl:value-of select="$domain"/>
    </domain>
    <xsl:text disable-output-escaping="yes">&#60;/account&#62;</xsl:text>
  </xsl:template>
  
  <xsl:template name="server">
    <xsl:param name="this"/>
    <xsl:text disable-output-escaping="yes">&#60;server id="</xsl:text>
    <xsl:value-of select="$this/@id"/>
    <xsl:text disable-output-escaping="yes">"&#62;</xsl:text>
    <base xmlns="http://janglin.com/Sycamores/MobileShare/Client/applicationData">
      <xsl:value-of select="$this/msc:base"/>
    </base>
    <address xmlns="http://janglin.com/Sycamores/MobileShare/Client/applicationData">
      <xsl:value-of select="$this/msc:address"/>
    </address>
    <port xmlns="http://janglin.com/Sycamores/MobileShare/Client/applicationData">
      <xsl:value-of select="$this/msc:port"/>
    </port>
    <xsl:text disable-output-escaping="yes">&#60;/server&#62;</xsl:text>
  </xsl:template>
</xsl:stylesheet>