﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sycamores.MobileShare.Client
{
    public partial class ConfigurationEditForm : EditForm
    {
        public ConfigurationEditForm()
        {
            InitializeComponent();

            SystemCheckBox.Text = Properties.Resources.CheckBoxSystem;
            HiddenFileCheckBox.Text = Properties.Resources.CheckBoxHidden;
            ExtensionsCheckBox.Text = Properties.Resources.CheckBoxExtension;
            SaveAccountInformation.Text = Properties.Resources.CheckBoxSavePassword;
        }

        public ConfigurationEditForm(ApplicationDataElement appData)
            : this()
        {
            mAppData = appData;

            InitializeForm();
        }

        private ApplicationDataElement mAppData;

        private void InitializeForm()
        {
            this.HiddenFileCheckBox.Checked = mAppData.ShowHiddenFiles;
            this.SystemCheckBox.Checked = mAppData.HideSystemFiles;
            this.ExtensionsCheckBox.Checked = mAppData.HideExtensions;
            this.SaveAccountInformation.Checked = mAppData.SaveAccount;

            foreach (ApplicationData.ServerElement server in mAppData.Servers.Values)
                ServerComboBox.Items.Add(server.Id);

            ServerComboBox.SelectedItem = mAppData.TargetServer;
        }

        protected override void DoneMenuItem_Click(object sender, EventArgs e)
        {
            mAppData.ShowHiddenFiles = this.HiddenFileCheckBox.Checked;
            mAppData.HideSystemFiles = this.SystemCheckBox.Checked;
            mAppData.HideExtensions = this.ExtensionsCheckBox.Checked;
            mAppData.SaveAccount = this.SaveAccountInformation.Checked;

            mAppData.TargetServer = ServerComboBox.SelectedItem.ToString();

            this.DialogResult = DialogResult.OK;
        }
    }
}