﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sycamores.MobileShare.Client
{
    public partial class DirectoryPropertiesForm : Form
    {
        DirectoryInfo mDirectoryInfo;

        public DirectoryPropertiesForm()
        {
            InitializeComponent();
        }

        public DirectoryPropertiesForm(DirectoryInfo directoryInfo)
            : this()
        {
            mDirectoryInfo = directoryInfo;
        }

        private void OkMenuItem_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Ignore;
        }

        private void IsReadOnlyCheckBox_CheckStateChanged(object sender, EventArgs e)
        {
            if (mDirectoryInfo.AttributesSpecified)
            {
                System.IO.FileAttributes attributes = (System.IO.FileAttributes)mDirectoryInfo.Attributes;

                HiddenCheckBox.Checked = (System.IO.FileAttributes.Hidden & attributes) != 0;
                ArchiveCheckBox.Checked = (System.IO.FileAttributes.Archive & attributes) != 0;
                CompressedCheckBox.Checked = (System.IO.FileAttributes.Compressed & attributes) != 0;
                EncryptedCheckBox.Checked = (System.IO.FileAttributes.Encrypted & attributes) != 0;
            }
            else
            {
                HiddenCheckBox.CheckState = CheckState.Indeterminate;
                ArchiveCheckBox.CheckState = CheckState.Indeterminate;
                CompressedCheckBox.CheckState = CheckState.Indeterminate;
                EncryptedCheckBox.CheckState = CheckState.Indeterminate;
            }
        }

        private void DirectoryPropertiesForm_Load(object sender, EventArgs e)
        {
            NameTextBox.Text = mDirectoryInfo.Name;
            DateModifiedTextBox.Text = mDirectoryInfo.LastWriteTime;
            DateCreatedTextBox.Text = mDirectoryInfo.CreationTime;

            IsReadOnlyCheckBox.CheckState = CheckState.Indeterminate;

            IsReadOnlyCheckBox_CheckStateChanged(this, EventArgs.Empty);
        }
    }
}