﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sycamores.MobileShare.Client.Communications
{
    public interface IEntranceEx : IEntrance
    {
        DirectoryInfo[] GetDirectories(string foldername);

        DirectoryInfo[] GetDirectories(string foldername, string searchPattern);

        FileInfo[] GetFiles(string foldername);

        FileInfo[] GetFiles(string foldername, string searchPattern);

        void Create(string foldername);

        DirectoryInfo CreateSubdirectory(string foldername, string path);

        void Create(string foldername, System.IO.FileAttributes attributes);

        DirectoryInfo CreateSubdirectory(string foldername, string path, System.IO.FileAttributes attributes);
    }

    partial class EntranceClient : IEntranceEx
    {
        #region IEntranceEx Members

        public DirectoryInfo[] GetDirectories(string foldername)
        {
            return this.GetDirectories(foldername, null, null);
        }

        public DirectoryInfo[] GetDirectories(string foldername, string searchPattern)
        {
            return this.GetDirectories(foldername, searchPattern, null);
        }

        public FileInfo[] GetFiles(string foldername)
        {
            return this.GetFiles(foldername, null, null);
        }

        public FileInfo[] GetFiles(string foldername, string searchPattern)
        {
            return this.GetFiles(foldername, searchPattern, null);
        }

        public void Create(string foldername) { Create(foldername, null); }

        public DirectoryInfo CreateSubdirectory(string foldername, string path) { return CreateSubdirectory(foldername, path, null); }

        public void Create(string foldername, System.IO.FileAttributes attributes) { Create(foldername, (int)attributes); }

        public DirectoryInfo CreateSubdirectory(string foldername, string path, System.IO.FileAttributes attributes)
        {
            return CreateSubdirectory(foldername, path, (int)attributes);
        }

        #endregion
    }
}