﻿using System;
using System.IO;

namespace Sycamores.MobileShare.Client
{
    /// <summary>Form to accept information with which to create a new folder.</summary>
    public partial class NewFolderForm : BinaryOperationForm
    {
        /// <summary>Default constructor.</summary>
        public NewFolderForm() { InitializeComponent(); }

        private void NewFolderForm_Load(object sender, EventArgs e)
        {
            NameTextBox.Focus();
        }

        /// <summary>Resulting folder name.</summary>
        public string FolderName { get { return NameTextBox.Text; } }

        /// <summary>Resulting folder attributes.</summary>
        public FileAttributes Attributes
        {
            get
            {
                FileAttributes attributes = FileAttributes.Directory;

                if (HiddenCheckBox.Checked) attributes = attributes | FileAttributes.Hidden;
                if (ReadonlyCheckBox.Checked) attributes = attributes | FileAttributes.Hidden;
                if (ArchiveCheckBox.Checked) attributes = attributes | FileAttributes.Hidden;

                return attributes;
            }
        }
    }
}