﻿using System;
using System.Windows.Forms;

using Res = Sycamores.MobileShare.Client.Properties.Resources;

namespace Sycamores.MobileShare.Client
{
    /// <summary>Options menu form.</summary>
    public partial class OptionsMenuForm : MenuForm
    {
        /// <summary>Default constructor.</summary>
        public OptionsMenuForm()
            : base(false)
        {
            InitializeComponent();
        }

        /// <summary>Create form with application data.</summary>
        /// <param name="element">Application data element.</param>
        public OptionsMenuForm(ApplicationDataElement element)
            : base(false)
        {
            InitializeComponent();

            mAppData = element;
        }

        private void OptionsMenuForm_Load(object sender, EventArgs e)
        {
            Add(Res.LabelConfiguration);
            Add(Res.LabelServers);

            if (mAppData.Servers.Count <= 0)
            {
                SelectedIndex = 1;
                ItemSelected();

                this.DialogResult = DialogResult.Ignore;
                this.Close();
                return;
            }
        }

        private ApplicationDataElement mAppData;

        /// <summary>Item selected.</summary>
        protected override void ItemSelected()
        {
            if (SelectedValue.Equals(Res.LabelServers))
            {
                using (ServerMenuForm form = new ServerMenuForm(mAppData))
                    form.ShowDialog();
            }
            else if (SelectedValue.Equals(Res.LabelConfiguration))
            {
                using (ConfigurationEditForm form = new ConfigurationEditForm(mAppData))
                    form.ShowDialog();
            }
        }
    }
}