﻿using System;
using Microsoft.Win32;
using System.Drawing;
using System.Linq;

namespace Sycamores.MobileShare.Client
{
    internal class RegistryEx
    {
        private string mExtention;
        //private string mFileType;
        private string mFileDescription;
        private string mIconFile;
        private int mIconIndex;
        private bool mHasDefaultIcon;

        public string Extention { get { return mExtention; } }
        //public string FileType { get { return mFileType; } }
        public string FileDescription { get { return mFileDescription; } }
        public string IconFile { get { return mIconFile; } }
        public int IconIndex { get { return mIconIndex; } }
        public bool HasDefaultIcon { get { return mHasDefaultIcon; } }

        public RegistryEx(string extension)
        {
            mExtention = extension;

            RegistryKey classesroot = Registry.ClassesRoot;
            RegistryKey key = classesroot.OpenSubKey(extension);

            if (key != null)
            {
                string filetypekeyvalue = GetDefaultValueString(key);

                key = classesroot.OpenSubKey(filetypekeyvalue);

                if (key != null)
                {
                    mFileDescription = GetDefaultValueString(key);

                    if (mFileDescription.Length > 0)
                    {
                        string[] icons = GetDefaultIconString(key).Split(',');

                        mIconFile = icons[0];
                        mIconIndex = Convert.ToInt32(icons[1]);
                        mHasDefaultIcon = true;
                    }
                }
            }
        }

        private static string GetDefaultValueString(RegistryKey key)
        {
            if (key.ValueCount > 0)
            {
                string[] names = key.GetValueNames();

                if ((from string name in names where name.Equals("Default") select name).Count() > 0)
                {
                    if (key.GetValueKind("Default").Equals(RegistryValueKind.String))
                    {
                        return key.GetValue("Default").ToString();
                    }

                    throw new InvalidOperationException("Value is not a string type.");
                }
            }

            return string.Empty;
        }

        private static string GetDefaultIconString(RegistryKey key)
        {
            RegistryKey iconkey = key.OpenSubKey("DefaultIcon");

            return GetDefaultValueString(iconkey);
        }
    }
}