﻿using System;
using System.Runtime.InteropServices;
using System.Drawing;

namespace Sycamores.PlatformInvokeCF.SystemServices
{
    public class SystemInformation
    {
        internal enum SystemMetric : int
        {
            SM_CXICON = 11,
            SM_CYICON = 12,
            SM_CXSMICON = 49,
            SM_CYSMICON = 50,
        }

        [DllImport("coredll.dll")]
        internal static extern int GetSystemMetrics(SystemMetric smIndex);
      
        /// <summary> 
        /// Get the associated Icon for a file or application.  Always returns 
        /// an icon.  If the filePath is invalid, the default icon for files of such type is returned. 
        /// </summary> 
        /// <returns></returns> 
        public static Size GetIconSizeLarge()
        {
            int width = GetSystemMetrics(SystemMetric.SM_CXICON);
            int height = GetSystemMetrics(SystemMetric.SM_CYICON);

            return new Size(width, height);
        }

        public static Size GetIconSizeSmall()
        {
            int width = GetSystemMetrics(SystemMetric.SM_CXSMICON);
            int height = GetSystemMetrics(SystemMetric.SM_CYSMICON);

            return new Size(width, height);
        }
    }
}