﻿using System;
using Microsoft.Win32;
using System.Drawing;

namespace TestFormApp
{
  public  class RegistryEx
    {
      public RegistryEx(string extension)
      {
          RegistryKey classesroot = Registry.ClassesRoot;

          RegistryKey key = classesroot.OpenSubKey(extension);

          string filetype = GetDefaultValueString(key);

          key = classesroot.OpenSubKey(filetype);

          string FileDescription = GetDefaultValueString(key);

          string icon = GetDefaultIconString(key);
      }

      private static string GetDefaultValueString(RegistryKey key)
      {
          if (key.GetValueKind("Default").Equals(RegistryValueKind.String))
          {
              return key.GetValue("Default").ToString();
          }

          throw new InvalidOperationException("Value is not a string type.");
      }

      private static string GetDefaultIconString(RegistryKey key)
      {
          RegistryKey iconkey = key.OpenSubKey("DefaultIcon");

          return GetDefaultValueString(iconkey);
      }
    }
}
