﻿using System;
using System.ServiceModel;

namespace Sycamores.MobileShare.Communications
{
    /// <summary></summary>
    /// <remarks></remarks>
    [ServiceContract(Namespace = "http://janglin.com/Sycamores/MobileShare/Communications")]
    public interface IExplorer
    {
        /// <summary></summary>
        /// <param name="value"></param>
        /// <returns></returns>
        [OperationContract]
        string ThisIsATest(string value);

        /// <summary></summary>
        /// <returns></returns>
        [OperationContract]
        string[] GetDomains();

        /// <summary></summary>
        /// <param name="domain"></param>
        /// <returns></returns>
        [OperationContract]
        string[] GetComputers(string domain);

        /// <summary></summary>
        /// <param name="computername"></param>
        /// <returns></returns>
        [OperationContract]
        NetworkShareInformation[] GetShares(string computername);

        /// <summary></summary>
        /// <param name="directorypath"></param>
        /// <returns></returns>
        [OperationContract]
        DirectoryInfo GetDirectoryInfo(string directorypath);

        /// <summary></summary>
        /// <param name="filepath"></param>
        /// <returns></returns>
        [OperationContract]
        FileInfo GetFileInfo(string filepath);

        /// <summary></summary>
        /// <param name="filepath"></param>
        /// <returns></returns>
        [OperationContract]
        string ExtractAssociatedIcon(string filepath);

        /// <summary></summary>
        /// <param name="username"></param>
        /// <param name="domain"></param>
        /// <param name="password"></param>
        /// <returns></returns>
        [OperationContract]
        string LogOn(string username, string domain, string password);

        #region DirectoryInfo

        /// <summary>Returns an array of directories in the current System.IO.DirectoryInfo matching the given search criteria and using
        /// a value to determine whether to search subdirectories.</summary>
        /// <param name="foldername">Directory in which to search.</param>
        /// should include only the current directory or should include all subdirectories</param>
        /// <returns>An array of type DirectoryInfo matching searchPattern.</returns>
        /// <exception cref="System.IO.DirectoryNotFoundException">The path encapsulated in the DirectoryInfo object is invalid, such as being on an unmapped drive.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        DirectoryInfo[] GetDirectories(string foldername);

        /// <summary>Returns an array of directories in the current System.IO.DirectoryInfo matching the given search criteria and using
        /// a value to determine whether to search subdirectories.</summary>
        /// <param name="foldername">Directory in which to search.</param>
        /// <param name="searchPattern">The search string, such as "System*", used to search for all directories beginning with the word "System".</param>
        /// should include only the current directory or should include all subdirectories</param>
        /// <returns>An array of type DirectoryInfo matching searchPattern.</returns>
        /// <exception cref="System.IO.DirectoryNotFoundException">The path encapsulated in the DirectoryInfo object is invalid, such as being on an unmapped drive.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        DirectoryInfo[] GetDirectories(string foldername, string searchPattern);

        /// <summary>Returns an array of directories in the current System.IO.DirectoryInfo matching the given search criteria and using
        /// a value to determine whether to search subdirectories.</summary>
        /// <param name="foldername">Directory in which to search.</param>
        /// <param name="searchPattern">The search string, such as "System*", used to search for all directories beginning with the word "System".</param>
        /// <param name="searchOption">One of the values of the System.IO.SearchOption enumeration that specifies whether the search operation
        /// should include only the current directory or should include all subdirectories</param>
        /// <returns>An array of type DirectoryInfo matching searchPattern.</returns>
        /// <exception cref="System.IO.DirectoryNotFoundException">The path encapsulated in the DirectoryInfo object is invalid, such as being on an unmapped drive.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        [OperationContract]
        DirectoryInfo[] GetDirectories(string foldername, string searchPattern, int? searchOption);

        /// <summary>Returns a file list from the current directory matching the given searchPattern and using a value to determine whether to search subdirectories.</summary>
        /// <param name="foldername">Directory in which to search.</param>
        /// <returns>An array of type System.IO.FileInfo.</returns>
        /// <exception cref="System.IO.DirectoryNotFoundException">The path encapsulated in the DirectoryInfo object is invalid, such as being on an unmapped drive.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        FileInfo[] GetFiles(string foldername);

        /// <summary>Returns a file list from the current directory matching the given searchPattern and using a value to determine whether to search subdirectories.</summary>
        /// <param name="foldername">Directory in which to search.</param>
        /// <param name="searchPattern">The search string, such as "System*", used to search for all directories beginning with the word "System".</param>
        /// <returns>An array of type System.IO.FileInfo.</returns>
        /// <exception cref="System.IO.DirectoryNotFoundException">The path encapsulated in the DirectoryInfo object is invalid, such as being on an unmapped drive.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        FileInfo[] GetFiles(string foldername, string searchPattern);

        /// <summary>Returns a file list from the current directory matching the given searchPattern and using a value to determine whether to search subdirectories.</summary>
        /// <param name="foldername">Directory in which to search.</param>
        /// <param name="searchPattern">The search string, such as "System*", used to search for all directories beginning with the word "System".</param>
        /// <param name="searchOption">One of the values of the System.IO.SearchOption enumeration that specifies whether the search operation
        /// <returns>An array of type System.IO.FileInfo.</returns>
        /// <exception cref="System.IO.DirectoryNotFoundException">The path encapsulated in the DirectoryInfo object is invalid, such as being on an unmapped drive.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        [OperationContract]
        FileInfo[] GetFiles(string foldername, string searchPattern, int? searchOption);

        /// <summary>Retrieves an array of strongly typed System.IO.FileSystemInfo objects representing the files and subdirectories matching the specified search criteria.</summary>
        /// <param name="foldername">Folder in which to look.</param>
        /// <returns>An array of strongly typed FileSystemInfo objects matching the search criteria.</returns>
        /// <exception cref="System.IO.DirectoryNotFoundException">The specified path is invalid, such as being on an unmapped drive.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        FileSystemInfo[] GetFileSystemInfos(string foldername);

        /// <summary>Retrieves an array of strongly typed System.IO.FileSystemInfo objects representing the files and subdirectories.</summary>
        /// <param name="foldername">Folder in which to look.</param>
          /// <param name="searchPattern">The search string, such as "System*", used to search for all directories beginning with the word "System".</param>
      /// <returns>An array of strongly typed FileSystemInfo objects.</returns>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        [OperationContract]
        FileSystemInfo[] GetFileSystemInfos(string foldername, string searchPattern);

        /// <summary>Creates a directory.</summary>
        /// <param name="foldername">Path of directory to be created.</param>
        /// <param name="attributes"></param>
        /// <exception cref="System.IO.IOException">The directory cannot be created.</exception>
        [OperationContract]
        void Create(string foldername, int? attributes);

        /// <summary>Creates a subdirectory or subdirectories on the specified path. The specified path can be relative to this instance of the System.IO.DirectoryInfo class.</summary>
        /// <param name="path">The specified path. This cannot be a different disk volume or Universal Naming Convention (UNC) name.</param>
        /// <remarks>Returns the last directory specified in path.</remarks>
        /// <param name="foldername">Path of directory to be created.</param>
        /// <param name="attributes"></param>
        /// <exception cref="System.ArgumentException">path does not specify a valid file path or contains invalid DirectoryInfo characters.</exception>
        /// <exception cref="System.ArgumentNullException">path is null.</exception>
        /// <exception cref="System.IO.PathTooLongException">The specified path, file name, or both exceed the system-defined maximum
        /// length. For example, on Windows-based platforms, paths must be less than 248 characters, and file names must be less than
        /// 260 characters. The specified path, file name, or both are too long.</exception>
        /// <exception cref="System.IO.IOException"> The subdirectory cannot be created.
        /// A file or directory already has the name specified by path.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have code access permission to create the directory.
        /// The caller does not have code access permission to read the directory described by the returned System.IO.DirectoryInfo object. 
        /// This can occur when the pathparameter describes an existing directory.</exception>
        /// <exception cref="System.NotSupportedException">path contains a colon character (:) that is not part of a drive label ("C:\").</exception>
        [OperationContract]
        DirectoryInfo CreateSubdirectory(string foldername, string path, int? attributes);

        /// <summary>Deletes this System.IO.DirectoryInfo if it is empty.</summary>
        /// <param name="foldername">Name of folder to delete.</param>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        /// <exception cref="System.IO.DirectoryNotFoundException">The directory described by this System.IO.DirectoryInfo 
        /// object does not exist or could not be found.</exception>
        void Delete(string foldername);

        /// <summary>Deletes this instance of a System.IO.DirectoryInfo, specifying whether to
        /// delete subdirectories and files.</summary>
        /// <param name="foldername"></param>
        /// <param name="recursive">True to delete this directory, its subdirectories, and all files; otherwise,
        /// false.</param>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        /// <exception cref="System.IO.DirectoryNotFoundException">The directory described by this System.IO.DirectoryInfo </exception>
        [OperationContract]
        void Delete(string foldername, bool? recursive);

        /// <summary>Moves a System.IO.DirectoryInfo instance and its contents to a new path.</summary>
        /// <param name="foldername">Source path.</param>
        /// <param name="destDirName">The name and path to which to move this directory. The destination cannot
        /// be another disk volume or a directory with the identical name. It can be
        /// an existing directory to which you want to add this directory as a subdirectory.</param>
        /// <exception cref="System.ArgumentNullException">destDirName is null.</exception>
        /// <exception cref="System.ArgumentException">destDirName is an empty string (''").</exception>
        /// <exception cref="System.IO.IOException">An attempt was made to move a directory to a different volume.
        /// or destDirName already exists.
        /// or You are not authorized to access this path.
        /// or The directory being moved and the destination directory have the same name.</exception>
        /// <exception cref="System.Security.SecurityException">The caller does not have the required permission.</exception>
        /// <exception cref="System.IO.DirectoryNotFoundException">The destination directory cannot be found.</exception>
        [OperationContract]
        void MoveTo(string foldername, string destDirName);

        #endregion
    }
}