﻿ using System;
using System.Runtime.Serialization;

using Sycamores.PlatformInvoke;

namespace Sycamores.MobileShare.Communications
{
    [DataContract(Namespace = "http://janglin.com/Sycamores/MobileShare/Communications")]
    public class NetworkShareInformation
    {
        public NetworkShareInformation(ShareInformation1 input)
        {
            NetName = input.NetName;
            ShareType = (NetworkShareTypeCode)input.ShareType;
            Remark = input.Remark;
        }

        [DataMember]
        public string NetName;

        [DataMember]
        public NetworkShareTypeCode ShareType;

        [DataMember]
        public string Remark;
    }

    /// <summary>A bitmask of flags that specify the type of share.</summary>
    /// <remarks>Calls to the NetShareSetInfo function ignore this member.</remarks>
    [DataContract(Namespace = "http://janglin.com/Sycamores/MobileShare/Communications")]
    [Flags]
    public enum NetworkShareTypeCode : uint
    {
        [EnumMember]
        DiskTree = 0x00000000,
        [EnumMember]
        PrintQueue = 0x00000001,
        [EnumMember]
        Device = 0x00000002,
        [EnumMember]
        Ipc = 0x00000003,
        [EnumMember]
        Special = 0x80000000,
        [EnumMember]
        Temporary = 0x40000000,
    }

}