﻿using System;
using System.Runtime.InteropServices;
//using System.Security.Principal;
//using System.Security.Permissions;

namespace Sycamores.PlatformInvoke.Security
{
    //[assembly: SecurityPermissionAttribute(SecurityAction.RequestMinimum, UnmanagedCode = true)]
    //[assembly: PermissionSetAttribute(SecurityAction.RequestMinimum, Name = "FullTrust")]
    internal class Authentication
    {
        [DllImport("advapi32.dll", SetLastError = true, CharSet = CharSet.Unicode)]
        internal static extern bool LogonUser(String lpszUsername
            , String lpszDomain
            , String lpszPassword
            , int dwLogonType
            , int dwLogonProvider
            , ref IntPtr phToken);
    }

    public enum LogonTypeCodes : int
    {
        Interactive=2,
    }

    public enum LogonProviderCodes : int
    {
        Default=0,
    }

    public class UserToken : IDisposable 
    {
        IntPtr mToken;

        public UserToken() { }

        ~UserToken() { Dispose(); }

        public bool LogonUser(String userName
           , String domainName
           , String password
           , LogonTypeCodes logonType
           , LogonProviderCodes logonProvider)
        {
            return Authentication.LogonUser(userName
           , domainName
           , password
           , (int)logonType
           , (int)logonProvider
           , ref mToken);
        }

        public static implicit operator IntPtr(UserToken token)
        {
            return token.mToken;
        }

        #region IDisposable Members

        private bool mDisposed;

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        private void Dispose(bool disposing)
        {
            if (!this.mDisposed)
            {
                SystemServices.SystemInformation.CloseHandle(mToken);
                mToken = IntPtr.Zero;

                mDisposed = true;
            }
        }
        
        #endregion
    }
}