﻿using System;
using System.ServiceModel;

using Sycamores.MobileShare.Communications;

[assembly: CLSCompliant(true)]
namespace Sycamores.MobileShare.Service
{
    /// <summary></summary>
    static class Program
    {
        /// <summary>The main entry point for the application.</summary>
        static void Main()
        {
            Uri baseAddress = new Uri("http://192.168.1.64:1750/Sycamores/MobileShare/");

            ServiceHost serviceHost = new ServiceHost(typeof(Explorer), baseAddress);

            try
            {
                serviceHost.AddServiceEndpoint(typeof(IExplorer), new BasicHttpBinding(), String.Empty);

                var mexbinding = System.ServiceModel.Description.MetadataExchangeBindings.CreateMexHttpBinding();

                serviceHost.AddServiceEndpoint(typeof(System.ServiceModel.Description.IMetadataExchange), mexbinding, "mex");

                //// Make the service discoverable over UDP multicast
                //serviceHost.Description.Behaviors.Add(new ServiceDiscoveryBehavior());
                //serviceHost.AddServiceEndpoint(new UdpDiscoveryEndpoint());

                serviceHost.Open();

                Console.WriteLine("Explorer Service started at {0}", baseAddress);
                Console.WriteLine();
                Console.WriteLine("Press <ENTER> to terminate the service.");
                Console.WriteLine();
                Console.ReadLine();
                serviceHost.Close();
            }
            catch (CommunicationException e) { Console.WriteLine(e.Message); }
            catch (TimeoutException e) { Console.WriteLine(e.Message); }

            if (serviceHost.State != CommunicationState.Closed)
            {
                Console.WriteLine("Aborting the service...");
                serviceHost.Abort();
            }
        }
    }
}