﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;
using System.Linq;
using System.ServiceProcess;

namespace Sycamores.MobileShare.Service
{
    /// <summary>Project installer.</summary>
    [RunInstaller(true)]
    public partial class ProjectInstaller : Installer
    {
        /// <summary>Default constructor.</summary>
        public ProjectInstaller() { InitializeComponent(); }

        /// <summary>On after install.</summary>
        /// <param name="savedState"></param>
        protected override void OnAfterInstall(IDictionary savedState)
        {
            TimeSpan timeout = TimeSpan.FromMilliseconds(30000);

            ServiceController service = null;

            try
            {
                service = new ServiceController("Mobile Share Service Host");

                if (service.Status.Equals(ServiceControllerStatus.Running)) service.Stop();

                service.WaitForStatus(ServiceControllerStatus.Stopped, timeout);

                service.Start();

                service.WaitForStatus(ServiceControllerStatus.Running, timeout);
            }
            catch (Exception ex) { Host.Log(ex.Message); }
            finally { if (service != null) service.Dispose(); }
        }
    }
}