﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Xml.Linq;

namespace Sycamores.XFramework
{
    public abstract class Entity
    {
        protected object Locker = new object();
        
        public static bool AttributeQualified;
        public static bool ElementQualified = true;

        private string mNamespace;

        public string Namespace { get { return mNamespace; } }

        protected Entity(string nameSpace) { mNamespace = nameSpace; }

        public abstract  string Tag { get; }

        protected XName GetElementName(string tag)
        {
            if (ElementQualified)
                return XName.Get(tag, mNamespace);
            else
                return tag;
        }

        protected XName GetAttributeName(string tag)
        {
            if (AttributeQualified)
                return XName.Get(tag, mNamespace);
            else
                return tag;
        }
    }
}